// ShareDlg.cpp : implementation file
//

#include "stdafx.h"
#include "ShareMan.h"
#include "ShareDlg.h"

#include "Structs.h"
#include "WndHlp.h"
#include "DropTarget.h"
#include "ShThrd.h"
#include "ShThrd.h"
#include "Utils.h"

#include <process.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


//extern IDropTargetShare *	lpDropTarget = (IDropTargetShare *)NULL;
extern UINT					g_cWndCountT;
extern UINT					g_cWndCountS;

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnImage();
	afx_msg void OnImageA();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	ON_WM_MOUSEMOVE()
	ON_BN_CLICKED(IDS_IMAGE, OnImage)
	ON_BN_CLICKED(IDS_IMAGE_A, OnImageA)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CShareManDlg dialog

CShareManDlg::CShareManDlg(CWnd* pParent /*=NULL*/)
	: 
	CDialog(CShareManDlg::IDD, pParent),
	m_lpDropTarget(NULL),
	m_fDragging(FALSE),
	m_hDragItem(NULL),
	m_hcurHand(NULL),
	m_hcurShareDragTV(NULL)
{
	//{{AFX_DATA_INIT(CShareManDlg)
	//}}AFX_DATA_INIT
	
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	DWORD dwSize = MAX_COMPUTERNAME_LENGTH + 1;
	TCHAR szMachineName[MAX_COMPUTERNAME_LENGTH + 1];
	GetComputerName(szMachineName, &dwSize);

	m_strMachineName = CString(szMachineName);
}

CShareManDlg::~CShareManDlg()
{
	Destroy();
}

void CShareManDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CShareManDlg)
	DDX_Control(pDX, IDT_SHARES, m_treeShare);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CShareManDlg, CDialog)
	//{{AFX_MSG_MAP(CShareManDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_DESTROY()
	ON_NOTIFY(TVN_DELETEITEM, IDT_SHARES, OnDeleteItem)
	ON_NOTIFY(TVN_SELCHANGED, IDT_SHARES, OnSelChanged)
	ON_WM_DROPFILES()
	ON_NOTIFY(TVN_BEGINDRAG, IDT_SHARES, OnBeginDrag)
	ON_WM_ACTIVATE()
	ON_WM_LBUTTONUP()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CShareManDlg message handlers

BOOL CShareManDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	Init();
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CShareManDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CShareManDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CShareManDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void 
CShareManDlg::Init()
{
	InitTree();

	ShowShareStatics(FALSE);
	ShowServerStatics(FALSE);
	
	LPSHAREINFO pshi = new SHAREINFO;
	unsigned uThreadId = 0;
	TCHAR tszEventName[_MAX_PATH + 1];

	m_lpDropTarget = new IDropTargetShare;
	if(m_lpDropTarget)
	{
		HRESULT hr = RegisterDragDrop(m_treeShare.m_hWnd, m_lpDropTarget);

		if(SUCCEEDED(hr))
			g_cWndCountT++;
	}

	//	now we have the dialog & list handles'
	pshi->hwndDlg	= m_hWnd;
	pshi->hwndTV	= m_treeShare.m_hWnd;

	_tcscpy(pshi->lpszMachineName, (LPCTSTR)m_strMachineName);

	// assume creation succeed
	_stprintf(tszEventName, _T("%s.CancelEnumSharing.%p.%ld"), AfxGetAppName(), m_hWnd, uThreadId);
	pshi->hCancelEvent	= CreateEvent(0, TRUE, FALSE, tszEventName);
	
	_stprintf(tszEventName, _T("%s.CloseEnumSharing.%p.%ld"), AfxGetAppName(), m_hWnd, uThreadId);
	pshi->hCloseEvent	= CreateEvent(0, TRUE, FALSE, tszEventName);

	if(pshi->hCancelEvent && pshi->hCloseEvent)
	{
		if(_beginthreadex(0, 0, FillShareList, (LPVOID)pshi, 0, &uThreadId) != 0)
			pshi->uThreadId = uThreadId;
	}
	else
	{
		if(pshi->hCancelEvent)
			CloseHandle(pshi->hCancelEvent);
		if(pshi->hCloseEvent)
			CloseHandle(pshi->hCloseEvent);

		#pragma warning(disable:4127)
		delete pshi;

		MessageBox(_T("Fail creation thread."), 0, MB_OK | MB_ICONINFORMATION);
	}
}

void 
CShareManDlg::ShowShareStatics(BOOL bShow)
{
	MultipleShowWindowByDlgId
		(
			m_hWnd, 
			bShow, 
			10, 
			IDS_TYPES, IDS_TYPE, 
			IDS_REMARKS, IDS_REMARK,
			IDS_MAXUSESS, IDS_MAXUSES,
			IDS_CURRENTUSESS, IDS_CURRENTUSES, 
			IDS_PATHS, IDS_PATH
		);
}

void 
CShareManDlg::ShowServerStatics(BOOL bShow)
{
	MultipleShowWindowByDlgId
		(
			m_hWnd, 
			bShow, 
			16, 
			IDS_PLATFORMS, IDS_PLATFORM,
			IDS_COMMENTS, IDS_COMMENT,
			IDS_MAXLOGINS, IDS_MAXLOGIN,
			IDS_SRVTYPES, IDS_SRVTYPE,
			IDS_AUTODISCONNECTS, IDS_AUTODISCONNECT,
			IDS_VISIBLES, IDS_VISIBLE,
			IDS_LICENSES, IDS_LICENSE,
			IDS_USERPATHS, IDS_USERPATH
		);
}

void 
CShareManDlg::ShowConnectionStatics(BOOL bShow)
{
	MultipleShowWindowByDlgId
		(
			m_hWnd, 
			bShow, 
			12, 
			IDS_NETNAMES, IDS_NETNAME,
			IDS_NUMOPENSS, IDS_NUMOPENS,
			IDS_NUMUSERSS, IDS_NUMUSERS,
			IDS_TIMES, IDS_TIME,
			IDS_CONNTYPES, IDS_CONNTYPE,
			IDS_USERNAMES2, IDS_USERNAME2
		);
}

void 
CShareManDlg::ShowFileStatics(BOOL bShow)
{
	MultipleShowWindowByDlgId
		(
			m_hWnd, 
			bShow, 
			10,
			IDS_PERMISSIONS, IDK_PERMREAD, IDK_PERMWRITE, IDK_PERMCREATE,
			IDS_NUMLOCKSS, IDS_NUMLOCKS,
			IDS_PATHNAMES, IDS_PATHNAME,
			IDS_USERNAMES, IDS_USERNAME
		);
}

void 
CShareManDlg::Destroy()
{
	ImageList_Destroy(m_hShareImageList);

	DestroyCursor(m_hcurHand);
	DestroyCursor(m_hcurShareDragTV);
}

void 
CShareManDlg::InitTree()
{
	m_hShareImageList = ImageList_LoadBitmap(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDB_SHARE), 
		16, 0, (COLORREF)(RGB(255, 255, 255)));

//	m_treeShare.SetImageList(pImgList, TVSIL_NORMAL);
	TreeView_SetImageList(m_treeShare.m_hWnd, m_hShareImageList, TVSIL_NORMAL);

	m_hcurShareDragTV	= AfxGetApp()->LoadCursor(IDCUR_SHARETVDRAG);
	m_hcurHand			= AfxGetApp()->LoadCursor(IDCUR_HAND);
}

void CShareManDlg::OnDestroy() 
{
	RevokeDragDrop(m_treeShare.m_hWnd);

	g_cWndCountT--;
	if(g_cWndCountT == 0)
	{
		if(m_lpDropTarget)
		{
			m_lpDropTarget->Release();
			delete m_lpDropTarget;
		}
	}

	CDialog::OnDestroy();
}

void CShareManDlg::OnDeleteItem(NMHDR* pNMHDR, LRESULT* pResult) 
{
	LPNMTREEVIEW lpNMTV = (NM_TREEVIEW*)pNMHDR;
	TCHAR lpszShareItem[_MAX_PATH + 1];

	if(lpNMTV->itemOld.lParam != 0)
	{
		TVITEM _tvItem = lpNMTV->itemOld;
		_tvItem.mask		= TVIF_PARAM | TVIF_TEXT;
		_tvItem.pszText		= lpszShareItem;
		_tvItem.cchTextMax	= _MAX_PATH + 1;
		
		if(m_treeShare.GetItem(&_tvItem))
		{
			LPTREESHARENODEINFO lpTSNI = (LPTREESHARENODEINFO)_tvItem.lParam;
			if((lpTSNI != (LPTREESHARENODEINFO)NULL) && !IsBadReadPtr(lpTSNI, sizeof(TREESHARENODEINFO)))
				delete lpTSNI;
		}
	}

	*pResult = 0;
}

void CShareManDlg::OnSelChanged(NMHDR* pNMHDR, LRESULT* pResult) 
{
	LPNMTREEVIEW lpNMTV = (LPNMTREEVIEW)pNMHDR;
//	UINT uCode = lpNMTV->hdr.code;
	TVITEM tvItem, tvRoot;
	HTREEITEM hItem, hRoot;

	TCHAR lpszShareItem[_MAX_PATH + 1];
	TCHAR lpszMachineName[MAX_COMPUTERNAME_LENGTH + 1];

	char lpszNetShareGetInfo[_MAX_PATH + 1];
	char lpszNetServerGetInfo[_MAX_PATH + 1];
	char lpszNetFileGetInfo[_MAX_PATH + 1];
	char lpszNetApi32Dll[_MAX_PATH + 1];
	char lpszNetApiBufferFree[_MAX_PATH + 1];

	HMODULE _hNetApi32 = 0;
	
	NETSHAREGETINFOPROC lpfnNetShareGetInfo = 0;
	NETSERVERGETINFOPROC lpfnNetServerGetInfo = 0;
	NETAPIBUFFERFREEPROC lpfnNetApiBufferFree = 0;
	NETFILEGETINFOPROC lpfnNetFileGetInfo = 0;

	NET_API_STATUS nas;
	
	PSERVER_INFO_102	pBufferS = 0;
	PSHARE_INFO_502		pBufferH = 0;
//	PCONNECTION_INFO_1	pConInfo1= 0;
	PFILE_INFO_3		pBufferF = 0;
	LPTREESHARENODEINFO pConInfo = 0;

	TCHAR lpszData[1024];
	DWORD dwFileId;

//
	hRoot = m_treeShare.GetRootItem();
	hItem = lpNMTV->itemNew.hItem;

	if(hItem && hRoot)
	{
		tvItem.mask			= TVIF_TEXT;
		tvItem.hItem		= hItem;
		tvItem.pszText		= lpszShareItem;
		tvItem.cchTextMax	= _MAX_PATH + 1;

		tvRoot.mask			= TVIF_TEXT;
		tvRoot.hItem		= hRoot;
		tvRoot.pszText		= lpszMachineName;
		tvRoot.cchTextMax	= MAX_COMPUTERNAME_LENGTH + 1;
		
		if(hItem != hRoot) // retrieve information about item
		{
			if(m_treeShare.GetParentItem(hItem) == hRoot) // share
			{
				ShowShareStatics(TRUE);
				ShowServerStatics(FALSE);
				ShowConnectionStatics(FALSE);
				ShowFileStatics(FALSE);

				if(m_treeShare.GetItem(&tvItem) && m_treeShare.GetItem(&tvRoot))
				{
					if(LoadStringA(AfxGetApp()->m_hInstance, IDS_NETSHAREGETINFO, lpszNetShareGetInfo, _MAX_PATH + 1) &&
					   LoadStringA(AfxGetApp()->m_hInstance, IDS_NETAPI32DLL, lpszNetApi32Dll, _MAX_PATH + 1) &&
					   LoadStringA(AfxGetApp()->m_hInstance, IDS_NETAPIBUFFERFREE, lpszNetApiBufferFree, _MAX_PATH + 1))
					{
						_hNetApi32 = LoadLibrary(lpszNetApi32Dll);
						if(_hNetApi32)
						{
							lpfnNetShareGetInfo = (NETSHAREGETINFOPROC)
								GetProcAddress(_hNetApi32, lpszNetShareGetInfo);

							lpfnNetApiBufferFree = (NETAPIBUFFERFREEPROC)
								GetProcAddress(_hNetApi32, lpszNetApiBufferFree);

							if(lpfnNetShareGetInfo && lpfnNetApiBufferFree)
							{
								nas = 
									(*lpfnNetShareGetInfo)
										(
										_WCSTR(lpszMachineName), 
										_WCSTR(lpszShareItem), 
										502, 
										(LPBYTE *)&pBufferH
										);
								if(nas == ERROR_SUCCESS)
								{
									//	 fill controls

							#if defined(UNICODE) || defined(_UNICODE)
									_tcscpy(lpszData, (LPTSTR)(pBufferH->shi502_remark));
							#else
									_tcscpy(lpszData, _MBSTR((LPWSTR)(pBufferH->shi502_remark)));
							#endif
									GetDlgItem(IDS_REMARK)->SendMessage(WM_SETTEXT, 0, (LPARAM)lpszData);

									//	type of sharing
									GetSharingType(pBufferH->shi502_type, (TCHAR *)lpszData);
									GetDlgItem(IDS_TYPE)->SendMessage(WM_SETTEXT, 0, (LPARAM)lpszData);

									//if(pBufferH[x].shi502_permissions == ACCESS_READ)

									//	max. uses
									if(pBufferH->shi502_max_uses == -1)
										_stprintf(lpszData, _T("Unlimited"));
									else
										_stprintf(lpszData, _T("%ld"), pBufferH->shi502_max_uses);
									GetDlgItem(IDS_MAXUSES)->SendMessage(WM_SETTEXT, 0, (LPARAM)lpszData);

									//	current uses
									_stprintf(lpszData, _T("%ld"), pBufferH->shi502_current_uses);
									GetDlgItem(IDS_CURRENTUSES)->SendMessage(WM_SETTEXT, 0, (LPARAM)lpszData);

									//	path
							#if defined(UNICODE) || defined(_UNICODE)
									_tcscpy(lpszData, (LPTSTR)(pBufferH->shi502_path));
							#else
									_tcscpy(lpszData, _MBSTR((LPWSTR)(pBufferH->shi502_path)));
							#endif
									GetDlgItem(IDS_PATH)->SendMessage(WM_SETTEXT, 0, (LPARAM)lpszData);

									(*lpfnNetApiBufferFree)(pBufferH);
								}
							}

							FreeLibrary(_hNetApi32);
						}
					}
				}
			}
			else // file or connection
			{
				HTREEITEM hCFItem = m_treeShare.GetParentItem(hItem);

				if(m_treeShare.GetParentItem(hCFItem) == hRoot) // connection
				{
					ShowServerStatics(FALSE);
					ShowShareStatics(FALSE);
					ShowConnectionStatics(TRUE);
					ShowFileStatics(FALSE);

					tvItem.mask		= TVIF_TEXT | TVIF_HANDLE | TVIF_PARAM;
					tvItem.hItem	= hItem;

					if(m_treeShare.GetItem(&tvItem))
					{
						pConInfo = (LPTREESHARENODEINFO)tvItem.lParam;

						if(pConInfo)
						{
							DWORD dwTime, dwDays, dwHours, dwMinutes, dwSeconds;

							//	network name
							if(pConInfo->lpszNetName)
						#if defined(UNICODE) || defined(_UNICODE)
							_tcscpy(lpszData, (LPTSTR)pConInfo->lpszNetName);
						#else
							_tcscpy(lpszData, _MBSTR((LPWSTR)pConInfo->lpszNetName));
						#endif
							else
								_tcscpy(lpszData, _T("")); 
							GetDlgItem(IDS_NETNAME)->SendMessage(WM_SETTEXT, 0, (LPARAM)(LPCTSTR)lpszData);

							//	currently opened file(s)
							_stprintf(lpszData, _T("%ld"), pConInfo->dwConnNumOpens);
							GetDlgItem(IDS_NUMOPENS)->SendMessage(WM_SETTEXT, 0, (LPARAM)(LPCTSTR)lpszData);

							//	users in connection
							_stprintf(lpszData, _T("%ld"), pConInfo->dwConnNumUsers);
							GetDlgItem(IDS_NUMUSERS)->SendMessage(WM_SETTEXT, 0, (LPARAM)(LPCTSTR)lpszData);

							//	seconds elapsed
							dwTime	= pConInfo->dwConnTime;

							dwDays	= dwTime / (3600 * 24);
							dwHours	= (dwTime - dwDays * 3600 * 24) / 3600;
							dwMinutes = (dwTime - dwDays * 3600 * 24 - dwHours * 3600) / 60;
							dwSeconds = (dwTime - dwDays * 3600 * 24 - dwHours * 3600 - dwMinutes * 60);

							if(dwDays > 0)
								_stprintf(lpszData, _T("%ld days, %2.2d:%2.2d:%2.2d"), dwDays, dwHours, dwMinutes, dwSeconds);
							else
								_stprintf(lpszData, _T("%2.2d:%2.2d:%2.2d (hh:mm:ss)"), dwHours, dwMinutes, dwSeconds);
							GetDlgItem(IDS_TIME)->SendMessage(WM_SETTEXT, 0, (LPARAM)(LPCTSTR)lpszData);

							//	type
							if(pConInfo->dwConnType != STYPE_SPECIAL)
							{
								GetSharingType(pConInfo->dwConnType, lpszData);
								GetDlgItem(IDS_CONNTYPE)->SendMessage(WM_SETTEXT, 0, (LPARAM)(LPCTSTR)lpszData);
							}

						#if defined(UNICODE) || defined(_UNICODE)
							_tcscpy(lpszData, (LPTSTR)pConInfo->lpszUserName);
						#else
							_tcscpy(lpszData, _MBSTR((LPWSTR)pConInfo->lpszUserName));
						#endif
							GetDlgItem(IDS_USERNAME2)->SendMessage(WM_SETTEXT, 0, (LPARAM)(LPCTSTR)lpszData);
						}
					}						
				}
				else
				{
					ShowServerStatics(FALSE);
					ShowShareStatics(FALSE);
					ShowConnectionStatics(FALSE);
					ShowFileStatics(TRUE);

					tvItem.mask = TVIF_PARAM; // we need the DWORD fileid 
					if(m_treeShare.GetItem(&tvItem) && m_treeShare.GetItem(&tvRoot))
					{
						if(LoadStringA(AfxGetApp()->m_hInstance, IDS_NETFILEGETINFO, lpszNetFileGetInfo, _MAX_PATH + 1) &&
						   LoadStringA(AfxGetApp()->m_hInstance, IDS_NETAPI32DLL, lpszNetApi32Dll, _MAX_PATH + 1) &&
						   LoadStringA(AfxGetApp()->m_hInstance, IDS_NETAPIBUFFERFREE, lpszNetApiBufferFree, _MAX_PATH + 1))
						{
							_hNetApi32 = LoadLibrary(lpszNetApi32Dll);
							if(_hNetApi32)
							{
								lpfnNetFileGetInfo = (NETFILEGETINFOPROC)
									GetProcAddress(_hNetApi32, lpszNetFileGetInfo);

								lpfnNetApiBufferFree = (NETAPIBUFFERFREEPROC)
									GetProcAddress(_hNetApi32, lpszNetApiBufferFree);

								if(lpfnNetFileGetInfo && lpfnNetApiBufferFree)
								{
									dwFileId = (DWORD)tvItem.lParam;

									nas = 
										(*lpfnNetFileGetInfo)
											(
											_WCSTR(lpszMachineName), 
											dwFileId, 
											3, 
											(LPBYTE *)&pBufferF
											);
									if(nas == ERROR_SUCCESS)
									{
										//	permission
										GetDlgItem(IDK_PERMREAD)->SendMessage(BM_SETCHECK, 
											(WPARAM)(pBufferF->fi3_permissions & PERM_FILE_READ), 0);
										GetDlgItem(IDK_PERMWRITE)->SendMessage(BM_SETCHECK, 
											(WPARAM)(pBufferF->fi3_permissions & PERM_FILE_WRITE), 0);
										GetDlgItem(IDK_PERMCREATE)->SendMessage(BM_SETCHECK, 
											(WPARAM)(pBufferF->fi3_permissions & PERM_FILE_CREATE), 0);

										//	num. locks
										_stprintf(lpszData, _T("%ld"), pBufferF->fi3_num_locks);
										GetDlgItem(IDS_NUMLOCKS)->SendMessage(WM_SETTEXT, 0, (LPARAM)lpszData);

										//	path name
								#if defined(UNICODE) || defined(_UNICODE)
										_tcscpy(lpszData, pBufferF->fi3_pathname);
								#else
										_tcscpy(lpszData, _MBSTR((LPWSTR)(pBufferF->fi3_pathname)));
								#endif
										GetDlgItem(IDS_PATHNAME)->SendMessage(WM_SETTEXT, 0, (LPARAM)lpszData);

										//	user name
								#if defined(UNICODE) || defined(_UNICODE)
										_tcscpy(lpszData, pBufferF->fi3_username);
								#else
										_tcscpy(lpszData, _MBSTR((LPWSTR)(pBufferF->fi3_username)));
								#endif
										GetDlgItem(IDS_USERNAME)->SendMessage(WM_SETTEXT, 0, (LPARAM)lpszData);

										(*lpfnNetApiBufferFree)(pBufferF);
									}
								}

								FreeLibrary(_hNetApi32);
							}
						}
					}
				}
			}
		}
		else // retrieve informations about server
		{
			ShowShareStatics(FALSE);
			ShowServerStatics(TRUE);
			ShowConnectionStatics(FALSE);
			ShowFileStatics(FALSE);

			if(m_treeShare.GetItem(&tvRoot))
			{
				if(LoadStringA(AfxGetApp()->m_hInstance, IDS_NETSERVERGETINFO, lpszNetServerGetInfo, _MAX_PATH + 1) &&
				   LoadStringA(AfxGetApp()->m_hInstance, IDS_NETAPI32DLL, lpszNetApi32Dll, _MAX_PATH + 1) &&
				   LoadStringA(AfxGetApp()->m_hInstance, IDS_NETAPIBUFFERFREE, lpszNetApiBufferFree, _MAX_PATH + 1))
				{
					_hNetApi32 = LoadLibrary(lpszNetApi32Dll);
					if(_hNetApi32)
					{
						lpfnNetServerGetInfo = (NETSERVERGETINFOPROC)
							GetProcAddress(_hNetApi32, lpszNetServerGetInfo);

						lpfnNetApiBufferFree = (NETAPIBUFFERFREEPROC)
							GetProcAddress(_hNetApi32, lpszNetApiBufferFree);

						if(lpfnNetServerGetInfo && lpfnNetApiBufferFree)
						{
							nas = 
								(*lpfnNetServerGetInfo)
									(
									_WCSTR(lpszMachineName), 
									102, 
									(LPBYTE *)&pBufferS
									);
							if(nas == ERROR_SUCCESS)
							{
								//	 fill controls
								//	platform
								if(pBufferS->sv102_platform_id == 500)
								{
									_stprintf(lpszData, _T("WindowsNT %ld.%ld"), 
										pBufferS->sv102_version_major & MAJOR_VERSION_MASK, 
										pBufferS->sv102_version_minor);
									GetDlgItem(IDS_PLATFORM)->SendMessage(WM_SETTEXT, 0, (LPARAM)lpszData);

								}
								//	comments
								#if defined(UNICODE) || defined(_UNICODE)
										_tcscpy(lpszData, pBufferS->sv102_comment);
								#else
										_tcscpy(lpszData, _MBSTR((LPWSTR)(pBufferS->sv102_comment)));
								#endif
								GetDlgItem(IDS_COMMENT)->SendMessage(WM_SETTEXT, 0, (LPARAM)lpszData);

								//	max login
								if(pBufferS->sv102_users == -1)
									_tcscpy(lpszData, _T("Unlimited"));
								else
									_stprintf(lpszData, _T("%ld"), pBufferS->sv102_users);
								GetDlgItem(IDS_MAXLOGIN)->SendMessage(WM_SETTEXT, 0, (LPARAM)lpszData);

								//	type
								GetServerType(pBufferS->sv102_type, (TCHAR *)lpszData);
								GetDlgItem(IDS_SRVTYPE)->SendMessage(WM_SETTEXT, 0, (LPARAM)lpszData);

								//	autodisconnect
								_stprintf(lpszData, _T("%ld"), pBufferS->sv102_disc);
								GetDlgItem(IDS_AUTODISCONNECT)->SendMessage(WM_SETTEXT, 0, (LPARAM)lpszData);
								//	hidden
								_tcscpy(lpszData, pBufferS->sv102_hidden == SV_HIDDEN ? _T("Yes") : _T("No"));
								GetDlgItem(IDS_VISIBLE)->SendMessage(WM_SETTEXT, 0, (LPARAM)lpszData);
								//	licenses
								_stprintf(lpszData, _T("%ld"), pBufferS->sv102_licenses);
								GetDlgItem(IDS_LICENSE)->SendMessage(WM_SETTEXT, 0, (LPARAM)lpszData);
								//	user path
								#if defined(UNICODE) || defined(_UNICODE)
										_tcscpy(lpszData, pBufferS->sv102_userpath);
								#else
										_tcscpy(lpszData, _MBSTR((LPWSTR)(pBufferS->sv102_userpath)));
								#endif
								GetDlgItem(IDS_USERPATH)->SendMessage(WM_SETTEXT, 0, (LPARAM)lpszData);

								(*lpfnNetApiBufferFree)(pBufferS);
							}
						}

						FreeLibrary(_hNetApi32);
					}
				}
			}
		}
	}

	*pResult = 0;
}

void CShareManDlg::OnDropFiles(HDROP hDropInfo) 
{
	UINT	cchFilesCount	= 0;
	UINT	cchFileNameSize	= 0;
	TCHAR *lpszFileName		= 0; 

	register UINT uFileIdx	= 0xFFFFFFFF;

	HMODULE _hNetApi32 = 0;
	SHARE_INFO_502 si502;
	DWORD dwParamIdxErr = 0;
	NET_API_STATUS nas = 0;

	_hNetApi32 = LoadLibrary("netapi32.dll");
	if(_hNetApi32)
	{
		LPFNNETSHAREADD lpfnNetShareAdd = (LPFNNETSHAREADD)GetProcAddress(_hNetApi32, "NetShareAdd");
		if(lpfnNetShareAdd)
		{
			cchFilesCount = DragQueryFile(hDropInfo, uFileIdx, 0, 0);
			if(cchFilesCount > 0)
			{
				for(uFileIdx = 0; uFileIdx < cchFilesCount; uFileIdx++)
				{
					cchFileNameSize = DragQueryFile(hDropInfo, uFileIdx, 0, 0);
					if(cchFileNameSize > 0)
					{
						lpszFileName = new TCHAR[cchFileNameSize + 1];
						if(lpszFileName)
						{
							DragQueryFile(hDropInfo, uFileIdx, lpszFileName, cchFileNameSize + 1);

							si502.shi502_netname			= (LPTSTR)_WCSTR(_tcsrev(_tcstok(_tcsrev(_tcsdup(lpszFileName)), _T("\\"))));
							si502.shi502_type				= STYPE_DISKTREE;
							si502.shi502_remark				= 0;
							si502.shi502_permissions		= ACCESS_READ;
							si502.shi502_max_uses			= 0xFFFFFFFF;
							si502.shi502_current_uses		= 0;
							si502.shi502_path				= (LPTSTR)_WCSTR(lpszFileName);
							si502.shi502_passwd				= 0;
							si502.shi502_reserved			= 0;
							si502.shi502_security_descriptor= 0;

							nas = (*lpfnNetShareAdd)(0, 502, (LPBYTE)&si502, &dwParamIdxErr);
							if(nas != NERR_Success)
							{
								ReportLastError(0, 0, TRUE, nas);
							}
							else
							{
								TVINSERTSTRUCT		tvInsS;
								TVITEMEX			tvItemExS;

								tvItemExS.mask				= TVIF_TEXT | TVIF_IMAGE | TVIF_SELECTEDIMAGE | TVIF_PARAM;
								tvItemExS.pszText			= _MBSTR((LPWSTR)si502.shi502_netname);
								tvItemExS.cchTextMax		= _MAX_PATH + 1;
								tvItemExS.iImage			= 1;
								tvItemExS.iSelectedImage	= 1;
								tvItemExS.lParam			= 0;

								tvItemExS.iImage			= si502.shi502_type & STYPE_IPC ? 8 : 0;
								tvItemExS.iSelectedImage	= si502.shi502_type & STYPE_IPC ? 8 : 0;
								
								tvInsS.hInsertAfter			= 0; 
								tvInsS.hParent				= m_treeShare.GetRootItem();
								tvInsS.itemex				= tvItemExS;

								m_treeShare.InsertItem(&tvInsS);
							}

							delete lpszFileName;
						}
					}
				}
			}

			FreeLibrary(_hNetApi32);
			_hNetApi32 = 0;
		}
		else
			ReportLastError(0, 0, TRUE, 0);
	}
}


void CShareManDlg::OnBeginDrag(NMHDR* pNMHDR, LRESULT* pResult) 
{
	LPNMTREEVIEW lpNMTV = (LPNMTREEVIEW)pNMHDR;
	*pResult = 0;

	TVITEM tvI;

	BeginDrag(lpNMTV);
	tvI = lpNMTV->itemNew;

	m_hDragItem = tvI.hItem;
}

void CShareManDlg::OnLButtonUp(UINT nFlags, CPoint point) 
{
	if(m_fDragging)
	{
		DropItem();
		ImageList_EndDrag();

		ReleaseCapture();
		ShowCursor(TRUE);
		
		m_fDragging = FALSE; 
	}

	CDialog::OnLButtonUp(nFlags, point);
}

void 
CShareManDlg::DropItem()
{
	TVITEM tvItem;
	char pszText[_MAX_PATH + 1];

	ZeroMemory(&tvItem, sizeof(TVITEM));
	tvItem.hItem		= m_hDragItem;
	tvItem.mask			= TVIF_TEXT;
	tvItem.pszText		= pszText;
	tvItem.cchTextMax	= _MAX_PATH + 1;

	wchar_t lpszUNCMachineName[MAX_COMPUTERNAME_LENGTH + 1];
	wcscpy(lpszUNCMachineName, L"\\\\");
	wcscat(lpszUNCMachineName, _WCSTR((LPSTR)(LPCSTR)m_strMachineName));

	if(m_treeShare.GetItem(&tvItem))
	{
		TCHAR lpszNetApi32Dll[_MAX_PATH + 1];
		char  lpszNetShareDel[_MAX_PATH + 1];

	    if( LoadString(AfxGetApp()->m_hInstance, IDS_NETAPI32DLL, lpszNetApi32Dll, _MAX_PATH + 1) &&
			LoadStringA(AfxGetApp()->m_hInstance, IDS_NETSHAREDEL, lpszNetShareDel, _MAX_PATH + 1))
		{
			HMODULE _hNetApi32 = LoadLibrary(lpszNetApi32Dll);
			if(_hNetApi32)
			{
				LPFNNETSHAREDEL lpfnNetShareDel = (LPFNNETSHAREDEL)GetProcAddress(_hNetApi32, lpszNetShareDel);
				LPWSTR lpwShareName = _WCSTR(pszText);

				NET_API_STATUS nas = (*lpfnNetShareDel)((LPWSTR)lpszUNCMachineName, (LPWSTR)lpwShareName, 0);
				if(nas != NERR_Success)
					ReportLastError(NULL, NULL, TRUE, nas);
				else
				{
					m_treeShare.DeleteItem(m_hDragItem);
					m_hDragItem = NULL;

					CString str;
					str.Format(_T("The sharing %S was succesfully removed."), lpwShareName);
					MessageBox(str, AfxGetAppName(), MB_OK | MB_ICONINFORMATION);
				}

				FreeLibrary(_hNetApi32);
			}
		}
	}

	SetCursor(LoadCursor(0, IDC_ARROW));

	m_treeShare.SelectDropTarget((HTREEITEM)NULL);
}

void 
CShareManDlg::BeginDrag(LPNMTREEVIEW lpNMTV)
{
	RECT rcl;

	HIMAGELIST hIml = TreeView_CreateDragImage(m_treeShare.m_hWnd, lpNMTV->itemNew.hItem);
	m_treeShare.GetItemRect(lpNMTV->itemNew.hItem, &rcl, TRUE);

	ImageList_BeginDrag(hIml, 0, lpNMTV->ptDrag.x, lpNMTV->ptDrag.y);

	ImageList_SetDragCursorImage(hIml, 0, 0, 0);

	ShowCursor(FALSE);
	SetCursor(m_hcurShareDragTV);
	ShowCursor(TRUE);

	m_treeShare.GetParent()->SetCapture();
	m_fDragging = TRUE;
}

void CAboutDlg::OnMouseMove(UINT nFlags, CPoint point) 
{
	CRect rcImage;
	GetDlgItem(IDS_IMAGE)->GetClientRect(&rcImage);
	
	BOOL fOverImage = PtInRect(&rcImage, point);

	GetDlgItem(IDS_IMAGE)->ShowWindow(fOverImage ? SW_HIDE : SW_SHOW);
	GetDlgItem(IDS_IMAGE_A)->ShowWindow(fOverImage ? SW_SHOW : SW_HIDE);

	if(PtInRect(&rcImage, point))
	{
		SetClassLong(m_hWnd, GCL_HCURSOR, (LONG)static_cast<CShareManDlg*>(GetParent())->m_hcurHand);
//		SetCursor(static_cast<CShareManDlg*>(GetParent())->m_hcurHand);
	}
	else
	{
		SetClassLong(m_hWnd, GCL_HCURSOR, (LONG)LoadCursor(0, IDC_ARROW));
//		SetCursor(LoadCursor(0, IDC_ARROW));
	}

	CDialog::OnMouseMove(nFlags, point);
}

void CAboutDlg::OnImage() 
{
	if(ShellExecute(m_hWnd, "open", _T("mailto:cr_amarie@hotmail.com"), 0, 0, SW_SHOW) <= (HINSTANCE)32)
		ReportLastError(0, 0, TRUE, 0);
}

void CAboutDlg::OnImageA() 
{
	if(ShellExecute(m_hWnd, "open", _T("mailto:cr_amarie@hotmail.com"), 0, 0, SW_SHOW) <= (HINSTANCE)32)
		ReportLastError(0, 0, TRUE, 0);
}
