// ShareDlg.h : header file
//

#if !defined(AFX_SHAREDLG_H__CF8EC70A_ED9A_4D25_BFE4_7281FDEB414E__INCLUDED_)
#define AFX_SHAREDLG_H__CF8EC70A_ED9A_4D25_BFE4_7281FDEB414E__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "DropTarget.h"

/////////////////////////////////////////////////////////////////////////////
// CShareManDlg dialog

class CShareManDlg : public CDialog
{
// Construction
public:
	HIMAGELIST m_hShareImageList;
	IDropTargetShare* m_lpDropTarget;

public:	
	void InitTree();
	void Destroy();

	void ShowFileStatics(BOOL bShow);
	void ShowConnectionStatics(BOOL bShow);
	void ShowServerStatics(BOOL bShow);
	void ShowShareStatics(BOOL bShow);
	
	void Init();

public:
	HCURSOR m_hcurHand;
	HCURSOR m_hcurShareDragTV;
	void BeginDrag(LPNMTREEVIEW lpNMTV);
	CString m_strMachineName;
	void DropItem();
	HTREEITEM m_hDragItem;
	BOOL m_fDragging;
	CShareManDlg(CWnd* pParent = NULL);	// standard constructor
	~CShareManDlg();

// Dialog Data
	//{{AFX_DATA(CShareManDlg)
	enum { IDD = IDD_SHAREMAN_DIALOG };
	CTreeCtrl	m_treeShare;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CShareManDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CShareManDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnDestroy();
	afx_msg void OnDeleteItem(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnSelChanged(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnDropFiles(HDROP hDropInfo);
	afx_msg void OnBeginDrag(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SHAREDLG_H__CF8EC70A_ED9A_4D25_BFE4_7281FDEB414E__INCLUDED_)
